image: node:12-slim

stages:
  - version
  - package
  - publish
  - release

version:
  stage: version
  image: registry.gitlab.com/juhani/go-semrel-gitlab:v0.21.1
  script:
    - release next-version --allow-current > .next-version
    - release changelog -f CHANGELOG.md --list-other-changes
  artifacts:
    paths:
    - .next-version
    - CHANGELOG.md
    expire_in: 1 week
  except:
    - tags

package:
  stage: package
  script:
    - npx vsce --version
    - echo "BUILD_NAME=sample-$(<.next-version)-$CI_COMMIT_SHORT_SHA.vsix" > build_info
    - echo "RELEASE_NAME=sample-$(<.next-version).vsix" >> build_info
    - echo "RELEASE_SHA=$CI_COMMIT_SHA" >> build_info
    - echo "RELEASE_VERSION=$(<.next-version)" >> build_info
    - . build_info
    - echo $BUILD_NAME
    - echo $RELEASE_NAME
    - echo $RELEASE_SHA
    - echo $RELEASE_VERSION
    - cat CHANGELOG.md
    - npm ci
    - npm version $RELEASE_VERSION --allow-same-version
    - npx vsce package -o $BUILD_NAME
  artifacts:
    paths:
      - '*.vsix'
      - build_info
      - package.json
    expire_in: 1 week
  except:
    - tags

publish:
  stage: publish
  environment: 
    name: production
  variables:
  script:
    - . build_info
    - echo $BUILD_NAME
    - echo $RELEASE_NAME
    - echo "RELEASE_URL=https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/jobs/$CI_JOB_ID/artifacts/$RELEASE_NAME" >> build_info
    - cp $BUILD_NAME $RELEASE_NAME
    - npx vsce publish -p $PAT --packagePath $RELEASE_NAME
  artifacts:
    paths:
      - '*.vsix'
      - build_info
  when: manual
  allow_failure: false
  only:
    - master

release:
  stage: release
  environment: 
    name: production
  image: registry.gitlab.com/juhani/go-semrel-gitlab:v0.21.1
  script:
    - . build_info
    - echo $RELEASE_NAME
    - echo $RELEASE_VERSION
    - echo $RELEASE_URL
    - release -v    
    - release commit-and-tag --list-other-changes CHANGELOG.md package.json
    - release --ci-commit-tag v$RELEASE_VERSION add-download-link -n $RELEASE_NAME -u $RELEASE_URL -d "$RELEASE_NAME"
  only:
    - master
